Bug 1694366 (pre-commit) - Review Request: pre-commit - Framework for managing and maintaining multi-language pre-commit hooks
Summary: Review Request: pre-commit - Framework for managing and maintaining multi-lan...
Keywords:
Status: CLOSED ERRATA
Alias: pre-commit
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: AwaitingSubmitter
Depends On: 1724202 1765196 1765263 1765265
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-30 18:55 UTC by Artem
Modified: 2020-02-26 17:59 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-26 17:59:01 UTC
Type: Bug
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Artem 2019-03-30 18:55:52 UTC
Spec URL: https://atim.fedorapeople.org/for-review/python-pre-commit.spec
SRPM URL: https://atim.fedorapeople.org/for-review/python-pre-commit-1.14.4-1.fc30.src.rpm

Description: A framework for managing and maintaining multi-language pre-commit hooks.

Fedora Account System Username: atim

Comment 1 Robert-André Mauchin 2019-04-01 20:29:09 UTC
 - Your package is noarch, you don't need this:

%global debug_package %{nil}

 No debuginfo is gathered for noarch packages.

 - Bump to 1.15.1, drop the patch that has been merged

 - Consider using: %?python_enable_dependency_generator

to automatically generates Requires instead of listing them. See https://fedoraproject.org/wiki/Changes/EnablingPythonGenerators#How_To_Test
(enabled by default in F30)

 - Please remove all the trailing spaces in your SPEC. Whatever editor you use there should be an option to remove trailing spaces on save.

 - Seems you don't have all Requires packaged yet:

DEBUG util.py:554:  BUILDSTDERR: Error: 
DEBUG util.py:554:  BUILDSTDERR:  Problem: conflicting requests
DEBUG util.py:554:  BUILDSTDERR:   - nothing provides python3.7dist(aspy.yaml) needed by python3-pre-commit-1.15.1-1.fc31.noarch
DEBUG util.py:554:  BUILDSTDERR:   - nothing provides python3.7dist(importlib-metadata) needed by python3-pre-commit-1.15.1-1.fc31.noarch
DEBUG util.py:554:  BUILDSTDERR:   - nothing provides python3.7dist(cfgv) >= 1.4.0 needed by python3-pre-commit-1.15.1-1.fc31.noarch
DEBUG util.py:554:  BUILDSTDERR:   - nothing provides python3.7dist(identify) >= 1.0.0 needed by python3-pre-commit-1.15.1-1.fc31.noarch

 - Run the tests with pytest

 - Simply use:

Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 170 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/python-pre-commit/review-python-pre-
     commit/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: https://docs.fedoraproject.org/en-US/packaging-
     guidelines/#_use_rpmlint
[x]: Spec file according to URL is the same as in SRPM.-commit-1.15.1-1.fc31.noarch.rpm



Rpmlint
-------
Checking: python3-pre-commit-1.15.1-1.fc31.noarch.rpm
          python-pre-commit-1.15.1-1.fc31.src.rpm
python3-pre-commit.noarch: W: devel-file-in-non-devel-package /usr/bin/pre-commit-validate-config
python3-pre-commit.noarch: W: no-manual-page-for-binary pre-commit
python3-pre-commit.noarch: W: no-manual-page-for-binary pre-commit-validate-config
python3-pre-commit.noarch: W: no-manual-page-for-binary pre-commit-validate-manifest
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 2 Miro Hrončok 2019-06-26 12:30:59 UTC
JFYI I'm packaging importlib-metadata for new tox.

Also, this should be called just pre-commit, not python-pre-commit and python3-pre-commit, thanks.

Comment 3 Miro Hrončok 2019-10-22 15:16:45 UTC
Can we please move this forward?

Comment 4 Artem 2019-10-22 15:20:26 UTC
Sure. Apologize, it required many python packages which was not packaged when i am first time tried to build it. < 2 days.

Comment 5 Artem 2019-10-24 12:29:14 UTC
Fixed 'python-pre-commit' but not fixed Tests yet:

https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01079060-python-pre-commit/python-pre-commit.spec

https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01079060-python-pre-commit/python-pre-commit-1.18.3-1.fc31.src.rpm

---

Packages which we still need to package for 'python-pre-commit':

  - nothing provides python3.7dist(aspy.yaml) needed by python3-pre-commit-1.18.3-1.fc31.noarch
  - nothing provides python3.7dist(cfgv) >= 2 needed by python3-pre-commit-1.18.3-1.fc31.noarch
  - nothing provides python3.7dist(identify) >= 1 needed by python3-pre-commit-1.18.3-1.fc31.noarch

Will start packaging them in alphabetical order.

Comment 6 Miro Hrončok 2019-10-24 12:33:19 UTC
This should be called just pre-commit, not python-pre-commit and python3-pre-commit, thanks.

Comment 10 Miro Hrončok 2019-10-24 19:39:42 UTC
BuildRequires:  python3dist(importlib-metadata)

This needs to be conditionalized for Fedora <= 31.

Comment 11 Artem 2019-10-24 19:52:28 UTC
(In reply to Miro Hrončok from comment #10)
> BuildRequires:  python3dist(importlib-metadata)
> 
> This needs to be conditionalized for Fedora <= 31.https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01079278-pre-commit/pre-commit.spechttps://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01079278-pre-commit/pre-commit-1.18.3-5.fc31.src.rpm

---

But we still need to fix tests. Now we here:

empty_template_setup (unittest.loader._FailedTest) ... ERROR
color_windows (unittest.loader._FailedTest) ... ERROR

ImportError: cannot import name 'windll' from 'ctypes' (/usr/lib64/python3.7/ctypes/__init__.py)

Comment 12 Miro Hrončok 2019-10-24 20:05:05 UTC
> ImportError: cannot import name 'windll' from 'ctypes'

Sounds very windows-y. Are you sure the way you run the test in %check is correct? Try running them with pytest maybe, as does upstream.

%check
%{python3} -m pytest -v

Comment 13 Miro Hrončok 2019-10-24 20:05:58 UTC
Another thing, I suggest using https://pre-commit.com as the URL.

Comment 14 Miro Hrončok 2019-10-24 20:07:18 UTC
And please replace:

  %{python3_sitelib}/pre_commit
  %{python3_sitelib}/pre_commit-%{version}-py?.?.egg-info

With:

  %{python3_sitelib}/pre_commit/
  %{python3_sitelib}/pre_commit-%{version}-py%{python3_version}.egg-info/


The slashes make sure this will always remain a directory. The ?.? glob would break with Python 3.10.

Comment 16 Miro Hrončok 2019-10-24 20:47:30 UTC
f31:

E                 git config --global user.email "you@example.com"
E                 git config --global user.name "Your Name"

actually do that before running the tests


rawhide:

pre_commit/constants.py:4: in <module>
    import importlib_metadata  # TODO: importlib.metadata py38?
E   ModuleNotFoundError: No module named 'importlib_metadata'

This will need an upstream patch. I can help, or if you want to try yourself, here are some examples:

https://github.com/pytest-dev/pluggy/pull/223
https://github.com/pytest-dev/pytest/pull/5539
https://github.com/tox-dev/tox/pull/1368

(unless this is already fixed in pre-commit master)

Comment 18 Artem 2019-10-26 13:54:30 UTC
@Miro, thank you, learned a lot from you.

> Here: https://github.com/pre-commit/pre-commit/commit/f8f81db36d3f43cee3a73e3377ce07df93b54d0e

This fixed and now it compiles fine with new python 3.8 in Rawhide.

---

There is still some test which we need to fix or disable few of them:

============== 33 failed, 557 passed, 6 skipped in 122.10 seconds ==============

---

For learning purposes i will choice another package next time, because IMHO this package is pretty serious and truth to be told i don't even need it now for my initial package which i want to have in repos, so i definitely ask for help you and co-maintain this pre-commit. Also i updating my package very quickly usually, but maybe i will not have to much time in future but this package requires good maintenance.

All required packages for pre-commit packaged BTW, few of them still on review.

---

https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01080573-pre-commit/pre-commit.spec

https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01080573-pre-commit/pre-commit-1.18.3-8.fc31.src.rpm

---

Build log F31: https://copr-be.cloud.fedoraproject.org/results/atim/python-packages/fedora-31-x86_64/01080573-pre-commit/builder-live.log.gz

Comment 19 Miro Hrončok 2019-10-26 20:13:55 UTC
I will gladly co-maintain this.

Comment 20 Anna Khaitovich 2019-10-31 10:44:22 UTC
Failed dependencies that I found:

Package that is obsolete in Fedora:
'python3dist(importlib-metadata)': [1]

Packages that have open Fedora Review requests:
'python3dist(aspy.yaml)': [2]
'python3dist(identify) >= 1.0.0' [3]

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1754151
[2] https://bugzilla.redhat.com/show_bug.cgi?id=1765196
[3] https://bugzilla.redhat.com/show_bug.cgi?id=1765265

Comment 21 Aniket Pradhan 2019-12-08 13:33:27 UTC
Hello everyone!

I am not able to get the latest spec/srpm (getting a 404). Anyways, I had written a spec as I was not aware of this request. Out of all the failing tests, only one test fails as they only make sense when testing on a virtual environment [0] (that test also requires pytest-env, not yet packaged for Fedora). We can disable that test and proceed further on.

We would also need to apply some patches to fix the remaining of the failing tests [1]-[2].

Other than that, here is my attempt at writing up a spec: https://major.fedorapeople.org/python-pre-commit/python-pre-commit.spec
SRPM: https://major.fedorapeople.org/python-pre-commit/python-pre-commit-1.20.0-1.fc31.src.rpm

The scratch build fails because I am not sure how to apply the patches for the same. For now, I have added the patches/diffs in the same directory.

I will change the name of the package as discussed above.

[0]: https://github.com/pre-commit/pre-commit/issues/1235#issuecomment-562868123
[1]: https://github.com/pre-commit/pre-commit/pull/1236
[2]: https://github.com/pre-commit/pre-commit/pull/1237

Comment 22 Miro Hrončok 2019-12-08 13:45:13 UTC
> how to apply the patches 

Does "%autosetup -p1" help?

Comment 23 Artem 2019-12-08 14:40:40 UTC
https://atim.fedorapeople.org/for-review/pre-commit.spec

https://atim.fedorapeople.org/for-review/pre-commit-1.20.0-1.fc32.src.rpm

Full build log with enabled tests:
https://atim.fedorapeople.org/for-review/build.log

> I am not able to get the latest spec/srpm (getting a 404).

Copr died today. I wrote in #fedora-buildsys about this. I can't check your spec and srpm as well - 404.

Comment 24 Aniket Pradhan 2019-12-08 17:38:40 UTC
Hey!

Thanks for providing the files.

I changed the name of the package, hence the path changed :P

Here are the new files:

spec: https://major.fedorapeople.org/pre-commit/pre-commit.spec
srpm: https://major.fedorapeople.org/pre-commit/pre-commit-1.20.0-1.fc31.src.rpm

The scratch build fails with some ambiguous reason: line 43: /usr/bin/git: No such file or directory

Here is the scratch: https://koji.fedoraproject.org/koji/taskinfo?taskID=39460974

The package builds fine locally.

Comment 25 Aniket Pradhan 2019-12-14 12:26:31 UTC
> spec: https://major.fedorapeople.org/pre-commit/pre-commit.spec
> srpm: https://major.fedorapeople.org/pre-commit/pre-commit-1.20.0-1.fc31.src.rpm

Updated the files above. The package now builds perfectly fine.

> The scratch build fails with some ambiguous reason: line 43: /usr/bin/git:
> No such file or directory

I just had to fix the ordering of the lines, so not much of an issue. Here [0] is the scratch build for the same.

[0]: https://koji.fedoraproject.org/koji/taskinfo?taskID=39563479

Comment 26 Aniket Pradhan 2020-01-20 11:56:00 UTC
Hello everyone!

Can we push this request further? The patches are no longer required in the new version of pre-commit.

@artem, since you had opened this request, then maybe you would have to provide the final spec/srpm which can be reviewed upon.

Comment 27 Artem 2020-01-20 12:42:45 UTC
(In reply to Aniket Pradhan from comment #26)
> @artem, since you had opened this request, then maybe you would have to
> provide the final spec/srpm which can be reviewed upon.

Sure. Will do shortly. And @Aniket i'll add you with full permission and full control of package.

Comment 29 chedi toueiti 2020-02-21 13:00:06 UTC
Hi everybody,

I would like to help with this package if possible as I'm one of the maintainers of python3-molecule that recently has added pre-commit as a runtime dependency.

Hope this get released for before the next release freeze

Comment 30 Robert-André Mauchin 2020-02-21 16:00:57 UTC
Package approved.

Comment 31 chedi toueiti 2020-02-24 14:13:05 UTC
congrats, when can we expect the package to be added to src.fedoraproject.org and be buildable in koji/bodhi ?

Comment 32 Gwyn Ciesla 2020-02-24 14:41:05 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/pre-commit

Comment 33 Artem 2020-02-24 15:26:26 UTC
(In reply to chedi toueiti from comment #31)
> congrats, when can we expect the package to be added to
> src.fedoraproject.org and be buildable in koji/bodhi ?

Hi, pushed to repos. I'll add @Miro, @major, @chedi as co-maintainers.

https://bodhi.fedoraproject.org/updates/FEDORA-2020-1473a3f45a

Comment 34 Miro Hrončok 2020-02-24 15:40:08 UTC
Can I add @python-sig as well?

Comment 35 Artem 2020-02-24 15:41:20 UTC
@Miro, sure!

Comment 36 Aniket Pradhan 2020-02-24 15:51:33 UTC
> Hi, pushed to repos. I'll add @Miro, @major, @chedi as co-maintainers.

Thanks for this @artem. I will start working on the package pre-commit was a dep for. :D

Comment 37 Fedora Update System 2020-02-26 17:59:01 UTC
pre-commit-2.1.0-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.